# -*- coding:Utf-8 -*-
# hud_hp V1.301p (22/03/2010) by DoCky


import es, os, psyco, langlib, playerlib, gamethread
psyco.full()

hh_info = es.AddonInfo()
hh_info.version = "1.301p"
hh_info.author = "DoCky"
hh_info.name = "hud_hp"

CvTeam = es.ServerVar("hh_team", "", "[hud_menu] player team that will receive hud menu (0-1-2)")
CvTime = es.ServerVar("hh_time", "", "[hud_menu] time (secondes) after round begin menu is showed")

gamedir = es.ServerVar("eventscripts_gamedir")
version = es.ServerVar(hh_info.name, hh_info.version, "by DoCky -")
version.set(hh_info.version)
version.makepublic()
timer = False
players = {}


class Player(object):
    """ manage player hud and message """

    def __init__(self, userid):
        self.userid = userid

        langdeft = langlib.getDefaultLang()
        languser = es.getclientvar(userid, "cl_language")
        langabrv = langdeft if not languser else langlib.getLangAbbreviation(languser)
        self.lang = langabrv if language["hud hp"].has_key(langabrv) else "en"

    def send(self):
        es.usermsg("create", "hh_send", "HintText")
        es.usermsg("write", "byte", "hh_send", "1")
        es.usermsg("write", "string", "hh_send", language("hud hp", {"healthpoint" : es.getplayerprop(self.userid, "CBasePlayer.m_iHealth")}, self.lang))
        es.usermsg("send", "hh_send", self.userid, "0")
        es.usermsg("delete", "hh_send")

    def hide(self):
        es.usermsg("create", "hh_hide", "ResetHUD")
        es.usermsg("write", "byte", "hh_hide", -1)
        es.usermsg("send", "hh_hide", self.userid, 1)
        es.usermsg("delete", "hh_hide")


def ticker():
    global timer
    timer = True
    for player in players.values(): player.send()
    gamethread.delayedname(5, "hud_hp_ticker", ticker)

def init():
    global language, teamid
    es.server.cmd("es_xmexec hud_hp/config.cfg")
    language = langlib.Strings(gamedir + "/cfg/hud_hp/language.ini")

    filter = int(CvTeam)
    if not filter: teamid, withtags = "23", "#human,#alive"
    elif filter == 1: teamid, withtags = "2", "#human,#alive,#t"
    elif filter == 2: teamid, withtags = "3", "#human,#alive,#ct"
    for userid in playerlib.getUseridList(withtags): players[str(userid)] = Player(userid)
    ticker()



def load():
    init()

def es_map_start(event):
    init()

def unload():
    gamethread.cancelDelayed("hud_hp_delay")
    gamethread.cancelDelayed("hud_hp_ticker")

def round_end(event):
    global timer
    timer = False
    gamethread.cancelDelayed("hud_hp_delay")
    gamethread.cancelDelayed("hud_hp_ticker")

def round_freeze_end(event):
    time = int(CvTime)
    if time <= 0: ticker()
    else: gamethread.delayedname(time, "hud_hp_delay", ticker)

def player_team(event):
    if event["disconnect"] == "1":
        if players.has_key(event["userid"]): del players[event["userid"]]
    else:
        team = event["team"]
        userid = event["userid"]
        if not es.isbot(userid):

            if team in teamid:
                if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
                    players[userid] = Player(userid)
                    if timer: players[userid].send()
            elif players.has_key(userid):
                if timer: players[userid].hide()
                del players[userid]

def player_spawn(event):
    team = event["es_userteam"]
    if team in teamid:
        userid = event["userid"]
        if not es.isbot(userid):
            if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
                players[userid] = Player(userid)
                if timer: players[userid].send()

def player_hurt(event):
    try:
        if timer: players[event["userid"]].send()
    except KeyError: pass

def player_death(event):
    try:
        userid = event["userid"]
        players[userid].hide()
        del players[userid]
    except KeyError: pass
